open Defs
open Lexer
open Printf
open Pprint
open Interp


let prg = ref (Program ("",[],[])) ;;

let _ =
  if Array.length (Sys.argv) < 2 
      then begin printf "name of source program expected\n"; exit (0) end;
  let fname = Sys.argv.(1) ^ ".pas" in
  if not (Sys.file_exists fname)
     then begin printf "file with name %s does not exist\n" fname; exit (0) end;
  try 
    let lexbuf = Lexing.from_channel (open_in fname) in
    prg := Parser.main Lexer.token lexbuf
  with
    Parsing.Parse_error -> addErrMsg (mr (!curr_line,!curr_col,String.length !curr_tok)) 
                                     ("stopped at token " ^ !curr_tok)
;;

if !errMessages=[]
then
  begin
    printf "starting interpreter\n";
    interProgram !prg
  end
else
  begin
    printf "errors occured:\n";
    for i=0 to List.length !errMessages -1 do
      printf "%s\n" (List.nth !errMessages i)
    done
  end




